@echo off
color 0a
title Prerequisite updates for Internet Explorer 11

SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

set CONFIG_ORIGIN=config.ini
set CONFIG_SWAP=.config.swp

set /a TYPE=64
if "%ProgramFiles(x86)%" equ "" (
	set /a TYPE=32
)

choice /c "Yn" /cs /m "Install Prerequisite updates."
set /a PREREQUISITE=-1
if %ERRORLEVEL% equ 1 (
	set /a PREREQUISITE=0
)

choice /c "Yn" /cs /m "Install Optional updates."
set /a OPTIONAL=-1
if %ERRORLEVEL% equ 1 (
	set /a OPTIONAL=0
)

if %PREREQUISITE% neq 0 (
	if %OPTIONAL% neq 0 (
		goto :BYE
	)
)

cls
echo. System type: %TYPE%-bit
if %PREREQUISITE% equ 0 (
	echo. Install Prerequisite updates.
)
if %OPTIONAL% equ 0 (
	echo. Install Optional updates.
)

choice /c "Yn" /cs /m "Are you ready?"
if %ERRORLEVEL% neq 1 (
	goto :BYE
)

cls
set /a TOTAL_INSTALL=0
if %PREREQUISITE% equ 0 (
	echo. Installing: Prerequisite updates.
	call :PROC_INSTALL "[PREREQUISITE_UPDATES_%TYPE%]"
)
if %OPTIONAL% equ 0 (
	echo. Installing: Optional updates.
	call :PROC_INSTALL "[OPTIONAL_UPDATES_%TYPE%]"
)

:COMPLETED
rem cls
if %TOTAL_INSTALL% gtr 0 (
	echo. Installation complete.
	echo. You must restart your computer for the updates to take effect.
	choice /c "Yn" /cs /m "Restart Now?"
	if !ERRORLEVEL! equ 1 (
		if exist "%CONFIG_SWAP%" (
			del /q "%CONFIG_SWAP%"
		)
		shutdown /r /t 0
		exit
	)
) else (
	echo. No updates installed.
)
goto :BYE

:PROC_INSTALL
set CONFIG_LABEL=%~1

cd . > "%CONFIG_SWAP%"

for /f "usebackq eol=# tokens=*" %%i in ("%CONFIG_ORIGIN%") do (
	>> "%CONFIG_SWAP%" echo %%i
)

set /a LINE_NUMBER=0
for /f "usebackq tokens=*" %%i in ("%CONFIG_SWAP%") do (
	set /a LINE_NUMBER+=1
	if "%%i" equ "%CONFIG_LABEL%" (
		call :INSTALL_PART_2
		goto :EOF
	)
)
echo. Not found %CONFIG_LABEL%.
goto :EOF

:INSTALL_PART_2
for /f "usebackq skip=%LINE_NUMBER% tokens=*" %%i in ("%CONFIG_SWAP%") do (
	set CURRENT=%%i
	if "!CURRENT:~0,1!" equ "[" (
		goto :EOF
	)
	echo Installing [%%i].
	wusa "%%i" /quiet /norestart
	set /a TOTAL_INSTALL+=1
)
goto :EOF

:BYE
echo. Goodbye!
ping /n 3 127.0.0.1 > nul
if exist "%CONFIG_SWAP%" (
	del /q "%CONFIG_SWAP%"
)
exit
